classdef CCopyableObject < handle
    %CCOPYABLEOBJECT An object that can be deep-copied
    
    properties
    end
    
    methods
        function varargout = dcopy(obj, varargin)
            %DCOPY - Deep copy of an object
            
            % If another object copied into this
            if nargin > 1
                source = varargin{1};
                a = obj;
            else
                source = obj;
                a = feval(class(obj));
            end
            mo = eval(['?', class(obj)]);    % Obtain the meta-object
            % Extract non-dependent properties
            ndp = findobj([mo.Properties{:}],...
                'Dependent',false,'Transient',false,'Constant',false);
            % Go through all non-dependent properties
            for idx = 1:length(ndp)
                % Deep-copy CCopyableObjects
                name = ndp(idx).Name;
                % TODO: && ~ishandle(source.(name)) check
                if (isa(source.(name),'CCopyableObject') && isvalid(source.(name)) )
                    nObjs = numel(source.(name));
                    a.(name) = eval([class(source.(name)),'.empty(0)']);
                    for iObj = 1:nObjs
                        a.(name)(iObj) = dcopy(source.(name)(iObj));
                    end
                    % TODO: check for listener copying
                else
                    a.(name) = source.(name);
                end
            end
            % Give output
            if nargout > 0
                varargout{1} = a;
            end
        end
    end % of public methods
end % of classdef
