classdef CGuiModule < CContained
    %CGUIMODULE A general base class for a Gui Module in separate Figure.
    methods
        function obj = CGuiModule(figurename)
            %CGUIMODULE Constructor initialising figure properties
            obj.hContainer = figure('Name', figurename,...
                'Visible', 'off', ...
                'NumberTitle', 'off', ...
                'Units', 'Pixels',...
                'MenuBar', 'None', ...
                'Color', get(0,'defaultUicontrolBackgroundColor'),...
                'CloseRequestFcn', @(src,event)finish(obj));
        end % of constructor
        
        function run(obj)
            %RUN Called when the module is started
            set(obj.hContainer, 'visible', 'on');
        end % of function run
        
        function finish(obj)
            %FINISH Called when the module is closed
            if (CSetupClass.exitRequest())
                set(obj.hContainer, 'visible', 'off');
                delete(obj.hContainer);
            end
        end % of function finish
    end % of public methods
end % of class CGuiModule
