classdef CPanel < handle
    %CPANEL Class representing a gui panel
    
    properties (GetAccess = public, SetAccess = immutable)
        hPanel  % handle to the uipanel
    end
    
    methods
        function obj = CPanel(parent, title)
            obj.hPanel = uipanel('parent', parent,...
                'Tag', title,...
                'Title', CBabel.getInstance().getText(title),...
                'units', 'pixels', ...
                'BorderType', 'line',...
                'FontUnits', 'pixels', ...
                'FontSize', 10, ...
                'FontWeight', 'bold', ...
                'ForeGroundColor', [.35 0 0], ...
                'HighLightColor', [.6 .6 .6], ...
                'ShadowColor', [.4 .4 .4]);
        end
        
        function h = get.hPanel(obj)
            h = obj.hPanel;
        end
    end
end
