classdef CUiTab < CContained
    %CUITAB A tab in a GUI
    properties (Access = protected)
        hParentGroup % handle to the parent uitabgroup object
    end
    
    methods
        function obj = CUiTab(hParentGroup, name)
            %CUITAB constructor
            obj.hParentGroup = hParentGroup;
            obj.hContainer = uitab('parent', hParentGroup.getContainer(),...
                'Title', CBabel.getInstance().getText(name),...
                'Tag', name);
            hParentGroup.register(obj);
        end
    end
    
    methods (Abstract)
        %SHOW called when a tab is swithed to
        show(obj)
        %HIDE called when a tab is closed
        hide(obj)
    end
end
