%COMPILE  Compile NIHu.Lab
%   COMPILE Compiles the NI FPGA Bitfiles to Matlab Classes and compiles
%   the mex functions

% Copyright 2010-2013 Peter Fiala

clear;
bitfiles = dir('NiFpga_*.h');
filenames = cell2mat(regexp({bitfiles.name}, 'NiFpga_(?<name>.*).h', 'names'));
filenames = {filenames.name};
mfiles = strcat('C', filenames, '.m');
pfiles = strcat('C', filenames, '.p');

disp('Compiling FPGA bitfiles to Matlab Classes');
try
    % delete old p files and m files if needed
    delete(pfiles{:});
    delete(mfiles{:});
    % generate new m files
    NiFpga2Matlab(filenames, 'CRIO');
    % compile into p files
    pcode(mfiles{:});
    % delete newly generated m files
    delete(mfiles{:});
catch M
    disp(M.message);
end

disp('Compiling Matlab Mex functions');
mex -O mex_source/mlssignal.mex.c mex_source/signal.c -output mlssignal_mex
mex -O mex_source/sweepsignal.mex.c mex_source/signal.c -output sweepsignal_mex
