#ifndef DEVICE_H
#define DEVICE_H

#include "Serialisable.h"

#include <string>
using std::string;

class CDevice : public CSerialisable
{
	string vendor;
	string model;
	unsigned serialNumber;

public:
	CDevice(const string &vendor = "", const string &model = "", unsigned serialNumber = 0)
		: vendor(vendor),
		  model(model),
		  serialNumber(serialNumber)
	{
	}

	virtual ~CDevice() {}

	const string &getVendor() const { return vendor; }
	void setVendor(const string &vendor) { this->vendor = vendor; }
	const string &getModel() const { return model; }
	void setModel(const string &model) { this->model = model; }
	unsigned getSerialNumber() const { return serialNumber; }
	void setSerialNumber(unsigned serialNumber) { this->serialNumber = serialNumber; }

	virtual std::istream &serialise(std::istream &is);
	virtual std::ostream &serialise(std::ostream &os) const;
};

#endif
