#include "Quantity.h"

#include <cstring>

char const *const CQuantity::EUs[] = {"V", "g", "Pa", "N"};
CQuantity::quantity_t const CQuantity::Quants[] = {CQuantity::Voltage, CQuantity::Acceleration, CQuantity::Pressure, CQuantity::Force};

std::istream &CQuantity::serialise(std::istream &is)
{
	const unsigned maxEUSize = 24;
	char q[maxEUSize];
	if (is >> std::setw(maxEUSize) >> q)
	{
		for (unsigned i = 0; i < 4; ++i)
			if (!strcmp(EUs[i], q))
				quantity = CQuantity::Quants[i];
	}
	return is;
}

std::ostream &CQuantity::serialise(std::ostream &os) const
{
	return os << EUs[quantity];
}
