#ifndef SENSOR_H
#define SENSOR_H

#include "Device.h"
#include "Quantity.h"

class CSensor : public CDevice
{
	CQuantity quantity;
	double nominalSensitivity;
	double actualSensitivity;
	bool requireICP;

public:
	CSensor(const std::string &vendor = "",
			const std::string &model = "",
			unsigned serialNumber = 0,
			const CQuantity &quantity = CQuantity::Voltage,
			double sensitivity = 0,
			bool ricp = false)
		: CDevice(vendor, model, serialNumber)
		, quantity(quantity)
		, nominalSensitivity(sensitivity)
		, actualSensitivity(sensitivity)
		, requireICP(ricp)
	{
	}

	double getNominalSensitivity() const { return nominalSensitivity; }
	void setNominalSensitivity(double value) { nominalSensitivity = value; }
	double getActualSensitivity() const { return actualSensitivity; }
	void SetActualSensitivity(double value) { actualSensitivity = value; }
	const CQuantity &getQuantity() const { return quantity; }
	bool getRequireICP() const { return requireICP; }
	void setRequireICP(bool value) { requireICP = value; }

	std::istream &serialise(std::istream &is);
	std::ostream &serialise(std::ostream &os) const;
};

#endif
